Package com.usatiuk.kleppmanntree

# Interface TreeNode<TimestampT extends Comparable<TimestampT>,PeerIdT extends Comparable<PeerIdT>,MetaT extends NodeMeta,NodeIdT>

All Superinterfaces:
  `Serializable`

All Known Implementing Classes:
  `JKleppmannTreeNode`

public interface TreeNode<TimestampT extends Comparable<TimestampT>,PeerIdT extends Comparable<PeerIdT>,MetaT extends NodeMeta,NodeIdT> extends Serializable

## Method Summary

Modifier and Type
Method
Description
`org.pcollections.PMap<String,NodeIdT>`
`children()`
`NodeIdT`
`key()`
`OpMove<TimestampT,PeerIdT,MetaT,NodeIdT>`
`lastEffectiveOp()`
`MetaT`
`meta()`
`default String`
`name()`
`NodeIdT`
`parent()`
`TreeNode<TimestampT,PeerIdT,MetaT,NodeIdT>`
`withChildren(org.pcollections.PMap<String,NodeIdT> children)`
`TreeNode<TimestampT,PeerIdT,MetaT,NodeIdT>`
`withLastEffectiveOp(OpMove<TimestampT,PeerIdT,MetaT,NodeIdT> lastEffectiveOp)`
`TreeNode<TimestampT,PeerIdT,MetaT,NodeIdT>`
`withMeta(MetaT meta)`
`TreeNode<TimestampT,PeerIdT,MetaT,NodeIdT>`
`withParent(NodeIdT parent)`

## Method Details

### key

NodeIdT key()

### parent

NodeIdT parent()

### lastEffectiveOp

OpMove<TimestampT,PeerIdT,MetaT,NodeIdT> lastEffectiveOp()

### meta

@Nullable MetaT meta()

### name

default String name()

### children

org.pcollections.PMap<String,NodeIdT> children()

### withParent

TreeNode<TimestampT,PeerIdT,MetaT,NodeIdT> withParent(NodeIdT parent)

### withLastEffectiveOp

TreeNode<TimestampT,PeerIdT,MetaT,NodeIdT> withLastEffectiveOp(OpMove<TimestampT,PeerIdT,MetaT,NodeIdT> lastEffectiveOp)

### withMeta

TreeNode<TimestampT,PeerIdT,MetaT,NodeIdT> withMeta(MetaT meta)

### withChildren

TreeNode<TimestampT,PeerIdT,MetaT,NodeIdT> withChildren(org.pcollections.PMap<String,NodeIdT> children)